<?php

namespace Drupal\simple_oauth_claims;

use Drupal\Core\Config\Entity\ConfigEntityListBuilder;
use Drupal\Core\Entity\EntityInterface;
use Drupal\simple_oauth\Entities\UserEntityWithClaims;
use Drupal\user\Entity\User;

/**
 * Provides a listing of claims.
 */
class ClaimListBuilder extends ConfigEntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['label'] = $this->t('Label');
    $header['id'] = $this->t('Machine name');
    $header['type'] = $this->t('Type');
    $header['status'] = $this->t('Status');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    /** @var \Drupal\simple_oauth_claims\ClaimInterface $entity */
    $row['label'] = $entity->label();
    $row['id'] = $entity->id();
    $row['type'] = $entity->getType();
    $row['status'] = $entity->status() ? $this->t('Enabled') : $this->t('Disabled');
    return $row + parent::buildRow($entity);
  }

  /**
   * {@inheritdoc}
   */
  public function render() {
    $identifier = \Drupal::currentUser()->id();
    $account = User::load($identifier);
    $serializer = \Drupal::service('serializer');
    $user_entity = new UserEntityWithClaims();
    $user_entity->setIdentifier($identifier);
    $data = $serializer
      ->normalize($user_entity, 'json', [$identifier => $account]);
    \Drupal::messenger()->addMessage(print_r($data, TRUE));

    return parent::render();
  }

}
